/*
 * BT_teplomer.c
 *
 * Created: 2.3.2013 20:09:03
 
 *  Author: Jan Kstel, kristel_ml@volny.cz, www.eljack.tk
 */ 



#define AVR_ATmega8L
#define F_CPU 8000000UL

#define ADC_VREF_TYPE 0xC0


#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/interrupt.h> 
#include <ctype.h>
#include "string.h"				// knihovny pro prci s etzci znak

#include "DS18B20.h"			// hlavikov soubor pro obsluhu ds18b20

char buffer[16]; 

int tt1 = 0; // promene pro desetine cisla
int tt2 = 0;
int tt = 0;


#define SW PINB0
#define LED PORTD7  // LED
//DS18B20 PORTC2



//*********USART*************
unsigned char USART_receive_0(void){
  	while(1)
	{
	  if(bit_is_set(UCSRA,RXC))   
	    {

	     return(UDR);
	    }
		return(0);
	}
}

void USART_send_0( unsigned char data){
	 
 while(!(UCSRA & (1<<UDRE)));
	 UDR = data;
}

void USART_putstring_0(volatile char* StringPtr){
		  
	 while(*StringPtr != 0x00){
	 USART_send_0(*StringPtr);
	 StringPtr++;}
}

//----------------------------------READ TEMPERATURE----------------------------------//
void read_temperature ()
{
	 uint8_t temperature[2];

	//Reset, skip ROM and start temperature conversion
	therm_reset();
	therm_write_byte(SKIP_ROM);
	therm_write_byte(CONVERT_T);

	//Wait until conversion is complete
	while(!therm_read_bit()); //DS18B20 send 1 for conversion is done

	//Reset, skip ROM and send command to read Scratchpad
	therm_reset();
	therm_write_byte(SKIP_ROM);
	therm_write_byte(READ_SCRAT);

	//Read Scratchpad (only 2 first bytes)
	temperature[0]=therm_read_byte();		//low byte
	temperature[1]=therm_read_byte();		//high byte

	tt1 = 0; // projistotu vymazat
	tt2 = 0;
	tt = 0;
 
	tt = ( temperature[1] << 8 ) |  temperature[0]; 
	tt=tt*10;
	tt=tt/16;  
	tt1=tt/10; 

	if (tt < 0)   //vypocet desetinneho mista
	{              //pri zaporne teplote              
	 tt2 = tt - tt1*10;	
	 tt2 = tt2*(-1);
	}     
	else    //vypocet pri kladne teplote  
	{                
	 tt2 = tt - tt1*10;	
	}
}

//-------------------------------ADC-----------------------------------------------
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
_delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void volt_m (unsigned int ad_in)// matematika pro vypocet realneho napeti
{
	tt1 = 0;
	tt2 = 0;
	tt = 0;
        unsigned int vysledek;
        float realne;
	    vysledek = read_adc(ad_in); 
        realne = (float) 3.3 / 1023;  // referencni napeti -- napajeci 
        realne = (float) realne * vysledek;
        tt = (float) realne * 100*6.35; //(6,35 je konsatnta pro delic)
 
	tt1=tt/100; 
    tt2 = tt - tt1*100; 	
  
}

void radek ()
{
    sprintf ( buffer , "\r\n") ; //novy radek
    USART_putstring_0(buffer);
    USART_putstring_0(buffer);	
	
}


//************************Hlavni prog*****************************

int main(void)
{
	
//------------nastaveni registru-------------------------
// External Interrupt(s) initialization
// INT0: on
// INT1: Off
MCUCR=0b00000010;
GICR=0b01000000;

PORTB=0x00;  
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0b10000000; //PORTD3  LED

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA = 0x00;
UCSRB = 0x18;
UCSRC = 0x86;
UBRRH = 0x00;
UBRRL = 0x33;	
	

//---
    PORTD ^= (1<<LED);
    _delay_ms(2000);
	sprintf ( buffer , "AT+NAME BT-Temp"); // pojmenuje po zapnuti 
	USART_putstring_0(buffer);
	PORTD ^= (1<<LED);
//-----------------------	
	
    while(1)
    {
   	
	 read_temperature(); // zmeri teplotu
	
	_delay_ms(10000);

 if (!(PINB & (1<<SW))) // je-li v log-nule - OFF DIP1
   {
  
    //------------------***** Funkce BT name ******** -----------------------
	
	sprintf ( buffer , "AT+NAME BT - Tepl:%2d.", tt1); // funguje meni nazev BT modulu
    USART_putstring_0(buffer);
	
	sprintf ( buffer , "%d", tt2); // funguje meni nazev BT modulu
    USART_putstring_0(buffer);
	
	sprintf ( buffer , "C"); // funguje meni nazev BT modulu
    USART_putstring_0(buffer);
	
	_delay_ms(35000);
	PORTD ^= (1<<LED); //blikne diodou (zmeni log stav led)
	_delay_ms(300);
	PORTD ^= (1<<LED);
		
  } 

 else    // ON - DIP1 - seriova linka
  {

 
//-----------****** Funkce BT seriova linka *******------------------------------------
	
    sprintf ( buffer , "         BT Teplomer V 1.0"); 
	USART_putstring_0(buffer);
  
    sprintf ( buffer , "\r\n") ; //novy radek(neco jako enter)
    USART_putstring_0(buffer);

	sprintf ( buffer , "---------------------------------------") ; 
	USART_putstring_0(buffer);
		
	radek ();

	
//---------------teplota---------------
	sprintf ( buffer , "Teplota:");
   USART_putstring_0(buffer);
	
	if (tt < 0 && tt1 > -1)  // tohle vypise minus tehdy kdyz jsou desetiny zaporne
     {
      sprintf ( buffer , "-") ; //novy radek(neco jako enter)
	  USART_putstring_0(buffer);
     }

    sprintf(buffer, "%2d.", tt1);
    USART_putstring_0(buffer);
    sprintf(buffer, "%dC", tt2);
    USART_putstring_0(buffer);
	
	radek ();

//----------AD prevodnik-------------

	sprintf ( buffer , "AD:");
    USART_putstring_0(buffer);

   volt_m (0b00000001); // spusti ad prevod na ADC1
  	sprintf(buffer, "%2d.", tt1); 
	USART_putstring_0(buffer);
	sprintf(buffer, "%dV", tt2);  
	USART_putstring_0(buffer);
	
	radek ();
   
 //------AD akumulatoru-------------  
   	sprintf ( buffer , "Napeti AKU:");
    USART_putstring_0(buffer);
   
   volt_m (0b00000000); // spusti ad prevod na ADC0
  	sprintf(buffer, "%2d.", tt1); 
	USART_putstring_0(buffer);
	sprintf(buffer, "%dV", tt2); 
	USART_putstring_0(buffer);
	radek ();
	
	sprintf ( buffer , "---------------------------------------") ; 
	USART_putstring_0(buffer);
	
	radek ();
	
	PORTD ^= (1<<LED); //blikne diodou
	_delay_ms(300);
	PORTD ^= (1<<LED);
	
	   }
	
    }
}